import java.util.*;

/**
 * Cette classe reprsente un timer
 */
public class Timer implements Runnable {
    /**
     * Attribut indiquant la date du dernier top 
     */
    private Date derniereAction;
    /**
     * Attribut indiquant le dlai entre deux tops
     */
    private long delaiAction;
    /**
     * Attribut indiquant la classe devant tre appele par le timer 
     */
    private Timerizable tm;
    /**
     * Constructeur du timer
     * @param d1 Date de rfrence pour les tops
     * @param d2 Dlai entre deux tops
     * @param t Classe devant tre appele par le timer
     */
    public Timer(Date d1, long d2,Timerizable t) {
	derniereAction=d1;
	delaiAction=d2;
	tm=t;
    }
    /**
     * Mthode lance lors de l'excution du thread
     */
    public void run() {
	do {
	    if(new Date().getTime()-derniereAction.getTime()>=delaiAction) {
		derniereAction=new Date();
		tm.timer();
	    }
	}
	while(true);
    }
    /**
     * Mthode mettant  zro la date du dernier top
     */
    public void zero() {
	derniereAction=new Date();
    }
    /**
     * Mthode permettant de changer le dlai
     * @param delai Nouveau dlai
     */
    public void changerDelai(long delai) {
	delaiAction=delai;
    }
}
    
