package easyNotify;


import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;


public class EasyNotifyStructuredPushSupplier extends EasyNotifySupplier{


    protected StructuredProxyPushConsumer structuredProxyPushConsumer;






    public EasyNotifyStructuredPushSupplier(ORB orb) throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb);
    }
    
    public EasyNotifyStructuredPushSupplier(ORB orb, Property[] initialQoS, Property[] initialAdmin) throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, initialQoS, initialAdmin);
    }

    public EasyNotifyStructuredPushSupplier(org.omg.CORBA.ORB orb, String notificationServiceMachine, String notificationServicePort) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, notificationServiceMachine, notificationServicePort);
    }

    public EasyNotifyStructuredPushSupplier(ORB orb, int channelId) throws ChannelNotFound , org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, channelId);
    }

    public EasyNotifyStructuredPushSupplier(org.omg.CORBA.ORB orb, String notificationServiceMachine, String notificationServicePort, int channelId) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin, org.omg.CosNotifyChannelAdmin.ChannelNotFound {
	super(orb, notificationServiceMachine, notificationServicePort, channelId);
    }









    public void connect() throws org.omg.CosNotifyChannelAdmin.AdminLimitExceeded, org.omg.CosEventChannelAdmin.AlreadyConnected {
	startConnect();
	System.out.println("rcupration du proxy");
	
	ProxyConsumer proxyConsumer = supplierAdmin.obtain_notification_push_consumer(ClientType.STRUCTURED_EVENT, proxyConsumerId);
	structuredProxyPushConsumer = StructuredProxyPushConsumerHelper.narrow(proxyConsumer);
	
	System.out.println("connexion sans callback");
	// connexion sans notification des changements ventuels
	structuredProxyPushConsumer.connect_structured_push_supplier(null);
    }


    public void disconnect(){
	System.out.println("dconnexion");
	structuredProxyPushConsumer.disconnect_structured_push_consumer();
    }
    

    /**
     * lancer un vnement
     **/
    public void push(EasyStructuredEvent event) throws org.omg.CosEventComm.Disconnected {
	System.out.println("push : "+event.toString());
	structuredProxyPushConsumer.push_structured_event(event.toStructuredEvent());
    }

}
	
